import { Plugin } from "vue";
import { VueGtmUseOptions } from "./config";
import GtmPlugin from "./plugin";
/**
 * Create the Vue GTM instance.
 *
 * @param options Options.
 * @returns The Vue GTM plugin instance.
 */
export declare function createGtm(options: VueGtmUseOptions): VueGtmPlugin;
declare module "@vue/runtime-core" {
    interface ComponentCustomProperties {
        /**
         * The Vue GTM Plugin instance.
         */
        $gtm: GtmPlugin;
    }
}
/**
 * Vue GTM Plugin.
 */
export declare type VueGtmPlugin = Plugin;
export { VueGtmUseOptions } from "./config";
declare const _default: VueGtmPlugin;
export default _default;
/**
 * Returns GTM plugin instance to be used via Composition API inside setup method.
 *
 * @returns The Vue GTM instance if the it was installed, otherwise `undefined`.
 */
export declare function useGtm(): GtmPlugin | undefined;
