import "url-search-params-polyfill";
import { VueGtmUseOptions } from "./config";
/**
 * Load GTM script tag.
 *
 * @param id GTM ID.
 * @param config The config object.
 */
export declare function loadScript(id: string, config?: Pick<VueGtmUseOptions, "defer" | "compatibility" | "queryParams">): void;
/**
 * Check if GTM script is in the document.
 *
 * @returns `true` if in the `document` is a `script` with `src` containing `googletagmanager.com/gtm.js`, otherwise `false`.
 */
export declare function hasScript(): boolean;
